#include <iostream>
using namespace std;

#include "capd/capdlib.h"
using namespace capd;
using namespace capd::alglib;
using namespace capd::matrixAlgorithms;

void mapdemo()
{
	IMap f = "par:a,b;var:x,y;fun:1-a*x^2+y,b*x;";	// definition of a map
   	f.setParameter("a", interval(14)/interval(10));		// setting parameters of the map
   	f.setParameter("b", interval(3)/interval(10));
	
	IVector x(2);
	IVector y(2);
	IMatrix Df(2,2);

	x[0] = interval(9,11)/interval(10);
	x[1] = interval(-1,1)/interval(10);

	y = f(x);
	Df = f[x];

	cout << "x = " << x << endl;	
	cout << "f(x) = "<< y << endl;		 
	cout << "f'(x) = "<< Df << endl;
}

int main(int argc, char* argv[])
{
  	cout.precision(5);
	try
	{
		mapdemo();				
	}
	catch(exception& e)
  	{
    		cout << "\n\nException caught: "<< e.what() << endl;
  	}
  return 0;
} 
